package com.ebts.web.controller.system;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.ebts.common.core.entity.Result;
import com.ebts.system.utils.FtpUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import com.ebts.common.annotation.Log;
import com.ebts.common.core.controller.BaseController;
import com.ebts.common.core.entity.entity.User;
import com.ebts.common.core.entity.model.LoginUser;
import com.ebts.common.enums.BusinessType;
import com.ebts.common.utils.SecurityUtils;
import com.ebts.common.utils.ServletUtils;
import com.ebts.framework.web.service.TokenService;
import com.ebts.system.service.UserService;

import javax.annotation.Resource;

/**
 * 个人信息 业务处理
 *
 * @author binlin
 */
@RestController
@RequestMapping("/system/user/profile")
public class ProfileController extends BaseController {
    @Resource
    private UserService userService;

    @Resource
    private TokenService tokenService;

    /**
     * 个人信息
     */
    @GetMapping
    public Result<Map<String, Object>> profile() {
        LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
        User user = loginUser.getUser();
        Map<String, Object> result = new HashMap<>();
        result.put("user",user);
        result.put("roleGroup", userService.selectUserRoleGroup(loginUser.getUsername()));
        result.put("postGroup", userService.selectUserPostGroup(loginUser.getUsername()));
        return Result.ok(result);
    }

    /**
     * 修改用户
     */
    @Log(title = "个人信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result updateProfile(@RequestBody User user) {
        if (userService.updateUserProfile(user) > 0) {
            LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
            // 更新缓存用户信息
            loginUser.getUser().setNickName(user.getNickName());
            loginUser.getUser().setPhonenumber(user.getPhonenumber());
            loginUser.getUser().setEmail(user.getEmail());
            loginUser.getUser().setSex(user.getSex());
            tokenService.setLoginUser(loginUser);
            return Result.ok();
        }
        return Result.error("修改个人信息异常，请联系管理员");
    }

    /**
     * 重置密码
     */
    @Log(title = "个人信息", businessType = BusinessType.UPDATE)
    @PutMapping("/updatePwd")
    public Result updatePwd(String oldPassword, String newPassword) {
        LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
        String userName = loginUser.getUsername();
        String password = loginUser.getPassword();
        if (!SecurityUtils.matchesPassword(oldPassword, password)) {
            return Result.error("修改密码失败，旧密码错误");
        }
        if (SecurityUtils.matchesPassword(newPassword, password)) {
            return Result.error("新密码不能与旧密码相同");
        }
        if (userService.resetUserPwd(userName, SecurityUtils.encryptPassword(newPassword)) > 0) {
            // 更新缓存用户密码
            loginUser.getUser().setPassword(SecurityUtils.encryptPassword(newPassword));
            tokenService.setLoginUser(loginUser);
            return Result.ok();
        }
        return Result.error("修改密码异常，请联系管理员");
    }

    /**
     * 头像上传
     */
    @Log(title = "用户头像", businessType = BusinessType.UPDATE)
    @PostMapping("/avatar")
    public Result<String> avatar(@RequestParam("avatarfile") MultipartFile file) throws IOException {
        if (!file.isEmpty()) {
            LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
            file.getName();
            String avatar = FtpUtils.uploadFtp(file);
            if (userService.updateUserAvatar(loginUser.getUsername(), avatar)) {
                loginUser.getUser().setAvatar(avatar);
                // 更新缓存用户头像
                tokenService.setLoginUser(loginUser);
                return Result.ok("上传成功",FtpUtils.getResources() + avatar);
            }
        }
        return Result.error("上传图片异常，请联系管理员");
    }
}
